#!/bin/bash
####################################################################
#--------------- vBulletin Charset Converter 1.1 ------------------#
#------------- Coded by : ALzaabi AKA 'NLP', 'Hz' -----------------#
#--------------------- h.alz3abi@gmail.com ------------------------#
####################################################################
########################### CONFIG #################################

######## Old Database Info ########
# Database Name.
dbname='example_dbname'

# Database Username.
username='example'

# Database Password
userpass='examplepassword'

#DB short CHARSET like latin1, ..etc
oldcharset_short=latin1

# DB LONG CHARSET like latin1_swedish_ci, ..etc
oldcharset_long=latin1_swedish_ci

######## New Database Info ########
## NEW DB SHORT CHARSET Like utf8, ..etc
newcharset_short=utf8

## NEW DB LONG CHARSET like utf8_general_ci, ..etc
newcharset_long=utf8_general_ci

######## ICONV Config ########
# FROM CHARSET 'Windows-1256'
from_iconv=windows-1256

# to CHARSET 'UTF-8'
to_iconv=UTF-8

###################### DO NOT EDIT BELOW ###########################
date=`date "+%d-%m-%y"`
clear
echo -e '\E[37;44m'
echo -e "\033[1m####################################################################"
echo "#--------------- vBulletin Charset Converter 1.1 ------------------#"
echo "#------------- Coded by : ALzaabi AKA 'NLP', 'Hz' -----------------#"
echo "#--------------------- h.alz3abi@gmail.com ------------------------#"
echo "####################################################################"; tput sgr0;echo;
read -s -n 1 -p "Press any key to START Converting . . ."; echo;
START=$(date +%s)
echo -e '\E[30;47m'"1. Copying DB to File"; tput sgr0;echo;
echo -e '\E[35;40m'"- Copying Tables FROM ${dbname} .. with ignore BLOB tables......"
echo -e '\E[31;40m'
mysqldump -u$username -p$userpass --default-character-set=$oldcharset_short --ignore-table=$dbname.block --ignore-table=$dbname.blog_attachment --ignore-table=$dbname.customavatar --ignore-table=$dbname.customprofilepic --ignore-table=$dbname.filedata --ignore-table=$dbname.stylevar --ignore-table=$dbname.stylevardfn --ignore-table=$dbname.socialgroupicon --ignore-table=$dbname.sigpic $dbname > $from_iconv-$dbname-$date.sql
echo -e '\E[35;40m'"Done."
echo "- Copying BLOB tables. ..."
echo -e '\E[31;40m'
mysqldump -u$username -p$userpass --default-character-set=$oldcharset_short $dbname block blog_attachment customavatar customprofilepic filedata stylevar stylevardfn socialgroupicon sigpic > $to_iconv-$dbname-$date-BLOB.sql
echo -e '\E[35;40m'"Done.";echo;
echo -e '\E[30;47m'
echo "####################################################################"
echo "#------------------------- Replacing ------------------------------#"
echo "####################################################################" ; tput sgr0;echo;
echo -e '\E[33;40m'"- Replace old CHARSET names (${oldcharset_short}) within ${newcharset_short}"; tput sgr0;
echo -e '\E[31;40m'
cat ./$from_iconv-$dbname-$date.sql | sed "s/SET NAMES ${oldcharset_short}/SET NAMES ${newcharset_short}/g" > tmp
cat ./tmp > ./$from_iconv-$dbname-$date.sql
rm -f ./tmp
echo -e '\E[35;40m'"Done."
echo
echo -e '\E[33;40m'"- Replace old BLOB CHARSET names (${oldcharset_short}) within ${newcharset_short}"; tput sgr0;
echo -e '\E[31;40m'
cat ./$to_iconv-$dbname-$date-BLOB.sql | sed "s/SET NAMES ${oldcharset_short}/SET NAMES ${newcharset_short}/g" > tmp
cat ./tmp > ./$to_iconv-$dbname-$date-BLOB.sql
rm -f ./tmp
echo -e '\E[35;40m'"Done.";echo;
echo -e '\E[33;40m'"- Replace old CHARSET (${oldcharset_short}) within ${newcharset_short}"; tput sgr0;
echo -e '\E[31;40m'
cat ./$from_iconv-$dbname-$date.sql | sed "s/CHARSET=${oldcharset_short}/CHARSET=${newcharset_short}/g" > tmp
cat ./tmp > ./$from_iconv-$dbname-$date.sql
rm -f ./tmp
echo -e '\E[35;40m'"Done.";echo;
echo -e '\E[33;40m'"- Replace old BLOB CHARSET (${oldcharset_short}) within ${newcharset_short}"; tput sgr0;
echo -e '\E[31;40m'
cat ./$to_iconv-$dbname-$date-BLOB.sql | sed "s/CHARSET=${oldcharset_short}/CHARSET=${newcharset_short}/g" > tmp
cat ./tmp > ./$to_iconv-$dbname-$date-BLOB.sql
rm -f ./tmp
echo -e '\E[35;40m'"Done.";echo;
echo -e '\E[33;40m'"- Replace old CHARSET set (${oldcharset_short}) within ${newcharset_short}"; tput sgr0;
echo -e '\E[31;40m'
cat ./$from_iconv-$dbname-$date.sql | sed "s/CHARACTER SET ${oldcharset_short} COLLATE ${oldcharset_long}/CHARACTER SET ${newcharset_short} COLLATE ${newcharset_long}/g" > tmp
cat ./tmp > ./$from_iconv-$dbname-$date.sql
rm -f ./tmp
echo -e '\E[35;40m'"Done.";echo;
echo -e '\E[33;40m'"- Replace old BLOB CHARSET set (${oldcharset_short}) within ${newcharset_short}"; tput sgr0;
echo -e '\E[31;40m'
cat ./$to_iconv-$dbname-$date-BLOB.sql | sed "s/CHARACTER SET ${oldcharset_short} COLLATE ${oldcharset_long}/CHARACTER SET ${newcharset_short} COLLATE ${newcharset_long}/g" > tmp
cat ./tmp > ./$to_iconv-$dbname-$date-BLOB.sql
rm -f ./tmp
echo -e '\E[35;40m'"Done.";echo;
echo -e '\E[30;47m'
echo "####################################################################"
echo "#------------------------ Converting ------------------------------#"
echo "####################################################################"; tput sgr0;echo;
echo -e '\E[33;40m'"3. Convert DB to ${to_iconv} via ICONV."; tput sgr0;
echo -e '\E[34;40m'"- Converting...."; tput sgr0;
echo -e '\E[31;40m'
iconv -c -f $from_iconv -t $to_iconv $from_iconv-$dbname-$date.sql > $to_iconv-$dbname-$date.sql
echo -e '\E[35;40m'"Done.";echo;
END=$(date +%s)
SEC=$(( $END - $START ))
echo -e '\E[30;43m'
echo "- - - - - - - - - "
echo "Congratulation ! Converting is Done. ;)"
echo -e "It took "'\E[31;43m'"$SEC"'\E[30;43m'" Seconds."
echo "NOW Please Create a New Database From cPanel .. etc, Then"
echo "Import:-"
echo "1- ${to_iconv}-${dbname}-${date}.sql"
echo "2- ${to_iconv}-${dbname}-${date}-BLOB.sql"
echo "- - - - - - - - - "
echo "Thanks you for using My Script. on any problem.Please contanct me On"
echo "Email: H.alz3abi@gmail.com | MSN webmaster@alz3abi.com"; tput sgr0;echo;